class Photo < ActiveRecord::Base
  belongs_to :guidepost, inverse_of: :photos
  belongs_to :osm_guidepost, inverse_of: :photos, foreign_key: :osm_guidepost_osmid, primary_key: :osmid

  mount_uploader :image, PhotoUploader
  
  def to_s; File.basename(image.current_path) end
  def guideposts_nearby(max_meters)
    Guidepost.nearby([lat,lon], max_meters)
  end
  def osm_guideposts_nearby(max_meters)
    OsmGuidepost.nearby([lat,lon], max_meters)
  end
  def auto_attach
    candidates = guideposts_nearby(700)
    result = if candidates.size == 0
      false
    elsif candidates.size == 1
      (candidates.first[0] < 70)
    elsif candidates.size > 1
      first = candidates.first[0]
      second = candidates.second[0]
      ((second>100 and first<second/10) or (second>50 and first<2) or (second>35 and first<1))
    end
    if result
      self.guidepost = candidates.first[1]
    end
    return result
  end
end
